// (c) 2022 cepstrum.co.jp           //
// This is not free software.        //
//
// FIR filter speed test
//

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <math.h>
#include <time.h>

#include "c2blas.h"

#define ITERATE 300000
#define FIRLEN  100000

float  h[FIRLEN];
float  xbuf[FIRLEN*2];
float  y;
float  x;

int64_t firix;

time_t start_time;
time_t finish_time;

int    i;
char   c;

//--------------------------------------------

int main() {

  for (i=0; i<FIRLEN; i=i+1) {
    h[i]=(float)rand()/(float)RAND_MAX-0.5;
    xbuf[i]=0.0;
    xbuf[i+FIRLEN]=0.0;
  }

  fprintf(stderr, "running %iloop %itap FIR filter\n", ITERATE, FIRLEN);
  fprintf(stderr, "please wait...\n");

  start_time=time(NULL);
  firix=0;
  for (i=0; i<ITERATE; i=i+1) {
    x=(float)rand()/(float)RAND_MAX-0.5;
    y=c2blas_fir(x, xbuf, h, FIRLEN, &firix);
    if (i%(int)(ITERATE/75)==0) {
      fprintf(stderr, "*");
    }
  }
  fprintf(stderr, "\n");
  finish_time=time(NULL);

  fprintf(stderr, "%i[sec]\n", (int)difftime(finish_time, start_time));
  fprintf(stderr, "hit retun key to exit");
  scanf("%c", &c);

}


